<?php

namespace Teknisa\CADFIS\Factories;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Geral\Entities\Paramgeral;
use Teknisa\Libs\Util\NewCode;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Teknisa\Model\Geral\Entities\Contctbl;

class Ger00000CadastramentosAutomaticoFactory {
  
    protected $connection;
    protected $newCode;

    public function __construct(EntityManager $entityManager, NewCode $newCode) {
      $this->connection = $entityManager->getConnection();
      $this->entityManager = $entityManager;
      $this->newCode = $newCode;
    }
    
    public function selectPrimaryKey($tableName) {  
    
        $sql = "SELECT COLUMN_NAME FROM ALL_CONS_COLUMNS 
                    WHERE TABLE_NAME = :PARAMS
                    AND CONSTRAINT_NAME = 'PK_'||:PARAMS
                    AND COLUMN_NAME <> 'NRORG'";
        
        $std = $this->connection->prepare($sql);
        
        $params = array(
            "PARAMS"       => $tableName
        );
        
        $std->execute($params);
        
        return $std->fetch();
        
    }
    
    public function verificaDadoClie($row) { 
    
        $sql = 'SELECT C.CDCLIENTE 	,
                 C.IDTPIJURCLIE 	,
                 C.NRINSJURCLIE 	,
                 C.NMRAZSOCCLIE 	,
                 C.NMFANTCLIE 	,
                 C.IDENDEMISCLI 	,
                 C.IDENDCFOPCLI	,
                 C.IDCLIEATIV 	,
                 C.IDPRIPUBCLIE 	,
                 C.IDVERSALDCLI 	,
                 C.IDUTSALDCLI 	,
                 C.IDCALCDVCLIE 	,
                 C.IDUTSUBCLIEN,
                 
                  E.IDTPENDECLIE	,
                  E.CDPAIS 	,
                  E.SGESTADO 	,
                  E.CDMUNICIPIO 	,
                  E.DSENDECLIE 	,
                  E.DSCOMPENDCLI 	,
                  E.NMBAIRCLIE 	,
                  E.NRCEPCLIE 	,
                  E.DSEMAILCLIE 	,
                  E.DSEMAILCLIENFE 	,
                  E.NRCELULARCLI 	,
                  E.NRTELRESICLI,
                 
                  EC.IDTPENDECLIE	IDTPENDECOBR,
                  EC.CDPAIS 	CDPAISCOBR,
                  EC.SGESTADO 	SGESTADOCOBR,
                  EC.CDMUNICIPIO 	CDMUNICCOBR,
                  EC.DSENDECLIE 	DSENDECOBR,
                  EC.DSCOMPENDCLI 	DSCOMPENDCOBR,
                  EC.NMBAIRCLIE 	NMBAIRCOBR,
                  EC.NRCEPCLIE 	NRCEPCCOBR,
                  EC.DSEMAILCLIE 	DSEMAILCOBR,
                  EC.DSEMAILCLIENFE 	DSEMAILCOBRNFE,
                  EC.NRCELULARCLI 	NRCELULARCOBR,
                  EC.NRTELRESICLI NRTELRESICOBR,
                  
                  ET.IDTPENDECLIE	IDTPENDEENTR,
                  ET.CDPAIS 	CDPAISCENTR,
                  ET.SGESTADO 	SGESTADOENTR,
                  ET.CDMUNICIPIO 	CDMUNICENTR,
                  ET.DSENDECLIE 	DSENDEENTR,
                  ET.DSCOMPENDCLI 	DSCOMPENDENTR,
                  ET.NMBAIRCLIE 	NMBAIRENTR,
                  ET.NRCEPCLIE 	NRCEPCENTR,
                  ET.DSEMAILCLIE 	DSEMAILENTR,
                  ET.DSEMAILCLIENFE 	DSEMAILENTRNFE,
                  ET.NRCELULARCLI 	NRCELULARENTR,
                  ET.NRTELRESICLI NRTELRESIENTR
                  
                 FROM CLIENTE C
                 JOIN ENDECLIE E ON E.CDCLIENTE=C.CDCLIENTE
                 LEFT JOIN ENDECLIE EC ON EC.CDCLIENTE=C.CDCLIENTE
                 LEFT JOIN ENDECLIE ET ON ET.CDCLIENTE=C.CDCLIENTE
                  WHERE C.CDCLIENTE = :PARAMS
                ';
        
        $std = $this->connection->prepare($sql);
        
        $params = array(
            "PARAMS"       => $row['IDTPIJURCLIE'].$row['NRINSJURCLIE']
        );
        
        $std->execute($params);
        
        return $std->fetch();
        
    }
    
    public function verificaDadoForn($row) { 
    
        $sql = 'SELECT F.CDFORNECED ,
                 F.IDTPIJURFORN 	,
                 F.NRINSJURFORN 	,
                 F.NRINSESTFORN 	,
                 F.NMRAZSOCFORN 	,
                 F.NMFANTFORN 	,
                 F.IDENDEMISFOR 	,
                 F.IDENDCFOPFOR 	,
                 F.IDPRIPUBFORN 	,
                 
                  EP.IDTPENDEFORN	,
                  EP.CDPAIS 	,
                  EP.SGESTADO 	,
                  EP.CDMUNICIPIO 	,
                  EP.DSENDEFORN 	,
                  EP.DSCOMPENDFOR 	,
                  EP.NMBAIRFORN 	,
                  EP.NRCEPFORN 	,
                  EP.DSEMAILFORN 	,
                  EP.DSEMAILFORNNFE 	,
                  EP.NRCELULARFOR,
                  EP.NRTELRESIFOR,
                 
                  EC.IDTPENDEFORN	IDTPENDECOBR,
                  EC.CDPAIS 	CDPAISCOBR,
                  EC.SGESTADO 	SGESTADOCOBR,
                  EC.CDMUNICIPIO 	CDMUNICCOBR,
                  EC.DSENDEFORN 	DSENDECOBR,
                  EC.DSCOMPENDFOR 	DSCOMPENDCOBR,
                  EC.NMBAIRFORN 	NMBAIRCOBR,
                  EC.NRCEPFORN 	NRCEPCCOBR,
                  EC.DSEMAILFORN 	DSEMAILCOBR,
                  EC.DSEMAILFORNNFE 	DSEMAILCOBRNFE,
                  EC.NRCELULARFOR 	NRCELULARCOBR,
                  EC.NRTELRESIFOR NRTELRESICOBR,
                  
                  ET.IDTPENDEFORN	IDTPENDEENTR,
                  ET.CDPAIS 	CDPAISCENTR,
                  ET.SGESTADO 	SGESTADOENTR,
                  ET.CDMUNICIPIO 	CDMUNICENTR,
                  ET.DSENDEFORN 	DSENDEENTR,
                  ET.DSCOMPENDFOR 	DSCOMPENDENTR,
                  ET.NMBAIRFORN 	NMBAIRENTR,
                  ET.NRCEPFORN 	NRCEPCENTR,
                  ET.DSEMAILFORN 	DSEMAILENTR,
                  ET.DSEMAILFORNNFE 	DSEMAILENTRNFE,
                  ET.NRCELULARFOR 	NRCELULARENTR,
                  ET.NRTELRESIFOR NRTELRESIENTR
                  
                 FROM FORNECEDOR F
                 JOIN ENDEFORN EP ON EP.CDFORNECED=F.CDFORNECED
                 LEFT JOIN ENDEFORN EC ON EC.CDFORNECED=F.CDFORNECED
                 LEFT JOIN ENDEFORN ET ON ET.CDFORNECED=F.CDFORNECED
                  WHERE F.CDFORNECED = :PARAMS
                ';
        
        $std = $this->connection->prepare($sql);
        
        $params = array(
              "PARAMS"     => $row['IDTPIJURFORN'].$row['NRINSJURFORN']
        );
        
        $std->execute($params);
        
        return $std->fetch();
        
    }
    
    public function verificaDadoNRINSJURFORN($row) { 
    
        $sql = 'SELECT F.CDFORNECED ,
                 F.NRINSJURFORN
                 FROM FORNECEDOR F
                 WHERE F.NRINSJURFORN = :PARAMS
                ';
        
        $std = $this->connection->prepare($sql);
        
        $params = array(
              "PARAMS"     => $row['NRINSJURFORN']
        );
        
        $std->execute($params);
        
        return $std->fetch();
        
    }
    
    public function verificaDadoCDPICTCCTB() { 
        $params = array();
        $tst = $this->entityManager->getRepository(Paramgeral::class)->findOneBy($params);
        return $tst;
    }
    
    public function verificaCentCust($row) { 
    
        $sql = 'SELECT CDCENTCUST
                 FROM CENTCUST 
                 WHERE CDCENTCUST = :PARAMS
                ';
        
        $std = $this->connection->prepare($sql);
        
        $params = array(
              "PARAMS"     => $row['CDCENTCUST']
        );
        
        $std->execute($params);
        
        return $std->fetch();
        
    }
    
    public function verificaDadoCDTPCTRECEB($row) { 
    
        $sql = 'SELECT CDTPCTRECEB
                 FROM TIPOCTRECEBER
                 WHERE CDTPCTRECEB = :PARAMS
                ';
        
        $std = $this->connection->prepare($sql);
        
        $params = array(
              "PARAMS"     => $row['CDTPCTRECEB']
        );
        
        $std->execute($params);
        
        return $std->fetch();
        
    }
    
    public function getUpdatesContaContabil($row) { 
    
        $sql = "SELECT
                'UPDATE '||TABLE_NAME||
                ' SET '|| COLUMN_NAME|| ' = '||CHR(39)||:PARAMS||CHR(39) AS LINHA
                FROM(
                SELECT DISTINCT U.TABLE_NAME, UU.COLUMN_NAME
                FROM USER_CONSTRAINTS U, USER_CONS_COLUMNS UU
                WHERE R_CONSTRAINT_NAME = 'PK_CONTCTBL'
                AND U.TABLE_NAME = UU.TABLE_NAME
                AND U.OWNER = UU.OWNER
                AND UU.COLUMN_NAME LIKE 'CDCONT%')
                ";
                
        $std = $this->connection->prepare($sql);
        
        $params = array(
              "PARAMS"     => $row
        );
        
        $std->execute($params);
        
        return $std->fetchAll();
        
    }
    
    public function updateContaContabil($sql){
        
        $std = $this->connection->prepare($sql);
        
        $std->execute();
        
    }
    
    public function getMaxContaContabil() { 
        $sql = "SELECT MAX(CDCONTCTBL) as CDCONTCTBL
                FROM (
                SELECT CDCONTCTBL FROM CONTCTBL
                WHERE UPPER(NMCONTCTBL) NOT LIKE '%PADRAO%'
                UNION
                SELECT CDCONTCTBL FROM CONTCTBL
                WHERE UPPER(NMCONTCTBL) NOT LIKE '%PADRÃO%')";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute();
        
        return $std->fetch();
        
    }
    
    public function deleteContaContabil() { 
        $sql = "DELETE FROM CONTCTBL
                WHERE CDCONTCTBL IN (SELECT DISTINCT CDCONTCTBL
                FROM (SELECT CDCONTCTBL
                FROM CONTCTBL
                WHERE UPPER(NMCONTCTBL) LIKE '%PADRAO%'
                UNION
                SELECT CDCONTCTBL
                FROM CONTCTBL
                WHERE UPPER(NMCONTCTBL) LIKE '%PADRÃO%'))";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute();
        
    }
    
    /**
     * Insere Ajuste Conta Receber
     * @param $nrorg
     * @param $cdfilial
     * @param $nrlanctonf
     * @param $dtajusterec
     * @param $cdajuctrec
     * @param $dsajusterec
     * @param $vrajusterec
     * @param $nrseqvenrec
     * @param $nrparcelarec
     * @param $cdclassfina
     * @param $cdempresa
     * @return Ajctreceber
     */
    public static function insereContaContabil(
        $cdcontctbl, $cdcontredu, $nmcontctbl, $cdnvcontctbl, $cdcontante, $idtipocont, $idnatucont,
        $idpadrrel, $idcontccus, $cdcontplanrefe, $cdcontrefepre, $cdcontrefeimuisen
    ){
        /** @var Contctbl $contctbl */
        $contctbl = New Contctbl();
        $contctbl->setCdcontctbl($cdcontctbl);
        $contctbl->setCdcontredu($cdcontredu);
        $contctbl->setNmcontctbl($nmcontctbl);
        $contctbl->setCdnvcontctbl($cdnvcontctbl);
        $contctbl->setCdcontante($cdcontante);
        $contctbl->setIdtipocont($idtipocont);
        $contctbl->setIdnatucont($idnatucont);
        $contctbl->setIdpadrrel($idpadrrel);
        $contctbl->setIdgrupoconta('N');
        $contctbl->setIdcontccus($idcontccus);
        $contctbl->setCdcontplanrefe($cdcontplanrefe);
        $contctbl->setCdcontrefepre($cdcontrefepre);
        $contctbl->setCdcontrefeimuisen($cdcontrefeimuisen);
        //$contctbl->setDtinclusao(DateUtil::getDataAtual());
        //$contctbl->setIdmovfluxo('R');
        return $contctbl;
    }
    
    public function verificaPrimaryKey($pk, $primaryKey, $table) { 
        $sql = 'SELECT * FROM '.$table.' 
                WHERE '.$pk.'=:PARAMS';
        
        $std = $this->connection->prepare($sql);
        
        $params = array(
            "PARAMS"       => $primaryKey
        );
        
        $std->execute($params);
        return $std->fetch();
        
    }
    
    public function verificaDado($row, $primaryKey, $table) { 
        $sql = 'SELECT * FROM '.$table.' 
                WHERE '.$primaryKey.'=:PARAMS';
        
        $std = $this->connection->prepare($sql);
        
        $params = array(
            "PARAMS"       => $row[$primaryKey]
        );
        
        $std->execute($params);
        return $std->fetch();
        
    }
    
    public function verificaClassFis($cdclassfisc){
        $sql = 'SELECT * FROM CLASFISCAL
                WHERE CDCLASFISC = :CDCLASFISC';
        
        $std = $this->connection->prepare($sql);
        
        $params = array(
            "CDCLASFISC"       => $cdclassfisc
        );
        
        $std->execute($params);
        return $std->fetch();
    }
    
    public function getMascaraProduto($nrorg) { 
    
        $sql = "SELECT CDPICTPROD FROM PARAMGERAL
                WHERE NRORG = :P_NRORG";
        
        $std = $this->connection->prepare($sql);
        
        $params = array(
            "P_NRORG"       => $nrorg
        );
        
        $std->execute($params);
        
        return $std->fetch()['CDPICTPROD'];
        
    }
    
    public function getProdEstoBD($cdarvprodesto, $nrorg) { 
    
        $sql = "SELECT CDPRODUTO FROM PRODUTO
                WHERE CDARVPROD = :P_CDARVPRODESTO
                AND NRORG = :P_NRORG";
        
        $std = $this->connection->prepare($sql);
        
        $params = array(
            "P_CDARVPRODESTO"   => $cdarvprodesto,
            "P_NRORG"           => $nrorg
        );
        
        $std->execute($params);
        
        return $std->fetch();
        
    }
    
    public function newCodeProdEsto($nrorg) {
        return $this->newCode->getCodeByTableName('PRODUTO', $nrorg);
    }
    
    public function callInsereAgrupa($cdarvprod, $stEdit = 'N') {
        $procedure = new StoredProcedure($this->connection, 'INSERE_AGRUPA');
        
        $procedure->addParam(new Param('P_CDARVPROD', Param::PARAM_INPUT, $cdarvprod,       Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_stEdit',    Param::PARAM_INPUT, $stEdit,          Param::PARAM_TYPE_STR));
   
        $procedure->execute();
    }
    
    public function validaEndereco($row){
        
        $erros = array();
        
        $erros['municipio'] = $this->validaMunicipio($row);
        $erros['estado'] = $this->validaEstado($row);
        $erros['pais'] = $this->validaPais($row);
        
        forEach($erros as $erro){
            if($erro){
                return $erro;
            }
        }
    }
    
    public function validaEnderecoCobr($row){
        
        $erros = array();
        
        $erros['municipio'] = $this->validaMunicipioCobr($row);
        $erros['estado'] = $this->validaEstadoCobr($row);
        $erros['pais'] = $this->validaPaisCobr($row);
        
        forEach($erros as $erro){
            if($erro){
                return $erro;
            }
        }
    }
    
    public function validaEnderecoEntr($row){
        
        $erros = array();
        
        $erros['municipio'] = $this->validaMunicipioEntr($row);
        $erros['estado'] = $this->validaEstadoEntr($row);
        $erros['pais'] = $this->validaPaisEntr($row);
        
        forEach($erros as $erro){
            if($erro){
                return $erro;
            }
        }
    }
    
    public function validaMunicipio($row){
        
        $sql = "SELECT CDMUNICIPIO FROM MUNICIPIO
        WHERE CDMUNICIPIO = :P_CDMUNICIPIO
        AND SGESTADO = :P_SGESTADO
        AND CDPAIS = :P_CDPAIS";
        
        $std = $this->connection->prepare($sql);
        
        $params = array(
            "P_CDMUNICIPIO"    => $row["CDMUNICIPIO"],
            "P_SGESTADO"       => $row["SGESTADO"],
            "P_CDPAIS"         => $row["CDPAIS"]
        );
        
        $std->execute($params);
        $retorno = $std->fetch();
        
        if($retorno == false){
            return "Municipio inválido. (Campo: CDMUNICIPIO)";
        }
        
    }
    
    public function validaMunicipioCobr($row){
        
        $sql = "SELECT CDMUNICIPIO FROM MUNICIPIO
        WHERE CDMUNICIPIO = :P_CDMUNICIPIO
        AND SGESTADO = :P_SGESTADO
        AND CDPAIS = :P_CDPAIS";
        
        $std = $this->connection->prepare($sql);
        
        $params = array(
            "P_CDMUNICIPIO"    => $row["CDMUNICIPIOCOBR"],
            "P_SGESTADO"       => $row["SGESTADOCOBR"],
            "P_CDPAIS"         => $row["CDPAISCOBR"]
        );
        
        $std->execute($params);
        $retorno = $std->fetch();
        
        if($retorno == false){
            return "Municipio inválido. (Campo: CDMUNICIPIOCOBR)";
        }
        
    }
    
    public function validaMunicipioEntr($row){
        
        
        $sql = "SELECT CDMUNICIPIO FROM MUNICIPIO
        WHERE CDMUNICIPIO = :P_CDMUNICIPIO
        AND SGESTADO = :P_SGESTADO
        AND CDPAIS = :P_CDPAIS";
        
        $std = $this->connection->prepare($sql);
        
        $params = array(
            "P_CDMUNICIPIO"    => $row["CDMUNICIPIOENTR"],
            "P_SGESTADO"       => $row["SGESTADOENTR"],
            "P_CDPAIS"         => $row["CDPAISENTR"]
        );
        
        $std->execute($params);
        $retorno = $std->fetch();
        
        if($retorno == false){
            return "Municipio inválido. (Campo: CDMUNICIPIOENTR)";
        }
        
    }
    
    public function validaEstado($row){
        
        $sql = "SELECT SGESTADO FROM ESTADO
        WHERE SGESTADO = :P_SGESTADO
        AND CDPAIS = :P_CDPAIS";
   
        $std = $this->connection->prepare($sql);
        
        $params = array(
            "P_SGESTADO"    => $row["SGESTADO"],
            "P_CDPAIS"      => $row["CDPAIS"]
        );
        
        $std->execute($params);
        $retorno = $std->fetch();
        
        if($retorno == false){
            return "Estado inválido. (Campo: SGESTADO)";
        }
        
    }
    
    public function validaEstadoCobr($row){
        
        $sql = "SELECT SGESTADO FROM ESTADO
        WHERE SGESTADO = :P_SGESTADO
        AND CDPAIS = :P_CDPAIS";
   
        $std = $this->connection->prepare($sql);
        
        $params = array(
            "P_SGESTADO"    => $row["SGESTADOCOBR"],
            "P_CDPAIS"      => $row["CDPAISCOBR"]
        );
        
        $std->execute($params);
        $retorno = $std->fetch();
        
        if($retorno == false){
            return "Estado inválido. (Campo: SGESTADOCOBR)";
        }
        
    }
    
    public function validaEstadoEntr($row){
        
        $sql = "SELECT SGESTADO FROM ESTADO
        WHERE SGESTADO = :P_SGESTADO
        AND CDPAIS = :P_CDPAIS";
   
        $std = $this->connection->prepare($sql);
        
        $params = array(
            "P_SGESTADO"    => $row["SGESTADOENTR"],
            "P_CDPAIS"      => $row["CDPAISENTR"]
        );
        
        $std->execute($params);
        $retorno = $std->fetch();
        
        if($retorno == false){
            return "Estado inválido. (Campo: SGESTADOENTR)";
        }
        
    }
    
    public function validaPais($row){
        
        $sql = "SELECT CDPAIS FROM PAIS
        WHERE CDPAIS = :P_CDPAIS";
   
        $std = $this->connection->prepare($sql);
        
        $params = array(
            "P_CDPAIS"    => $row["CDPAIS"]
        );
        
        $std->execute($params);
        $retorno = $std->fetch();
        
        if($retorno == false){
            return "País inválido. (Campo: CDPAIS)";
        }
        
    }
    
    public function validaPaisCobr($row){
        $sql = "SELECT CDPAIS FROM PAIS
        WHERE CDPAIS = :P_CDPAIS";
   
        $std = $this->connection->prepare($sql);
        
        $params = array(
            "P_CDPAIS"    => $row["CDPAISCOBR"]
        );
        
        $std->execute($params);
        $retorno = $std->fetch();
        
        if($retorno == false){
            return "País inválido. (Campo: CDPAISCOBR)";
        }
        
    }
    
    public function validaPaisEntr($row){
        
        $sql = "SELECT CDPAIS FROM PAIS
        WHERE CDPAIS = :P_CDPAIS";
   
        $std = $this->connection->prepare($sql);
        
        $params = array(
            "P_CDPAIS"    => $row["CDPAISENTR"]
        );
        
        $std->execute($params);
        $retorno = $std->fetch();
        
        if($retorno == false){
            return "País inválido. (Campo: CDPAISENTR)";
        }
        
    }
    
    public function getParamsProduct(){
        
        $sql = "SELECT CDNIVPROD,CDVRINICNIVPROD,CDSEQNIVPROD FROM PARAMIMPPROD";
        
        $std = $this->connection->prepare($sql);
        $std->execute();
        $rows = $std->fetchAll();
        
        $filteredRows = array();
        
        $newI = 0;
        for($i = 0; $i < count($rows); $i++){
            $newI += 1; 
            
            $filteredRows ["NIVEL$newI"]["VRINICIO"] = $rows[$i]['CDVRINICNIVPROD'];
            $filteredRows ["NIVEL$newI"]["VRSEQUENCIAL"] = $rows[$i]['CDSEQNIVPROD'];
        }
        return $filteredRows;
    }
    
    public function getResultArvProd(){
        $sql = "SELECT CDARVPROD FROM PRODUTO";
   
        $std = $this->connection->prepare($sql);
        
        $std->execute();
        
        return $std->fetchAll();
        
    }
    
    public function validaMedida($value){
        
        $sql = "SELECT SGUNIDADE FROM UNIDMEDIDA WHERE SGUNIDADE = :SGUNIDADE";
   
        $std = $this->connection->prepare($sql);
        
        $params = array(
            "SGUNIDADE" => $value
        );
        
        $std->execute($params);
        
        return $std->fetch();
    }
}